unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Grids, StdCtrls, ComCtrls, Menus, ExtCtrls;

const MAX_DELKA=60;
  MAX_RADKU=20;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Edit1: TEdit;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Otevt1: TMenuItem;
    N1: TMenuItem;
    Konec1: TMenuItem;
    ProgressBar1: TProgressBar;
    Button1: TButton;
    Button2: TButton;
    Label2: TLabel;
    Edit2: TEdit;
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    procedure Konec1Click(Sender: TObject);
    procedure Otevt1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure JedenKrok();
    procedure Edit1Change(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    puvodni, nove: array [0..MAX_RADKU+1,0..MAX_DELKA+1] of char;
    delka, pocet, pocet_kroku:integer;
    bezi_animace:Boolean;
  public

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.Konec1Click(Sender: TObject);
begin
  Close();
end;

procedure TForm1.Otevt1Click(Sender: TObject);
var radek, sloupec:integer;
begin
  if OpenDialog1.Execute() then
  begin
    if bezi_animace then
    begin
      bezi_animace:=false;
      Button2.Enabled:=true;
      Button1.Caption:='Spustit animaci';
      Timer1.Enabled:=false;
    end;
    ProgressBar1.Max:=StrToInt(Edit1.Text);
    ProgressBar1.Position:=0;
    pocet_kroku:=0;
    Button1.Enabled:=true;
    Button2.Enabled:=true;
    Caption:='ivot - ' + OpenDialog1.FileName;
    Memo1.Lines.LoadFromFile(OpenDialog1.FileName);
    pocet:=0;
    while pocet<Memo1.Lines.Count do
    begin
      if (Length(Memo1.Lines[pocet])>0) and (pocet<MAX_RADKU) then Inc(pocet)
      else Memo1.Lines.Delete(pocet);
    end;
    delka:=Length(Memo1.Lines[0]);
    if delka>MAX_DELKA then delka:=MAX_DELKA;
    StatusBar1.Panels[0].Text:='Poet dk: ' + IntToStr(pocet) + '   Poet znak na dku: ' + IntToStr(delka);
    for radek:=0 to MAX_RADKU+1 do
      for sloupec:=0 to MAX_DELKA+1 do puvodni[radek,sloupec]:=' ';
    for radek:=1 to pocet do
      for sloupec:=1 to delka do puvodni[radek,sloupec]:=Memo1.Lines[radek-1][sloupec];
  end;
end;

procedure TForm1.Jedenkrok();
var radek, sloupec, pocet_zivych :integer;
  temp:String;
begin
  Inc(pocet_kroku);
  If pocet_kroku>StrToInt(Edit1.Text) then exit;
  StatusBar1.Panels[0].Text:='Zbv krok: ' + IntToStr(ProgressBar1.Max - pocet_kroku);
  ProgressBar1.Position:=pocet_kroku;
  for radek:=1 to pocet do
    for sloupec:=1 to delka do
    begin
      pocet_zivych:=0;
      if puvodni[radek-1,sloupec-1]='O' then Inc(pocet_zivych);
      if puvodni[radek-1,sloupec]='O' then Inc(pocet_zivych);
      if puvodni[radek-1,sloupec+1]='O' then Inc(pocet_zivych);
      if puvodni[radek,sloupec-1]='O' then Inc(pocet_zivych);
      if puvodni[radek,sloupec+1]='O' then Inc(pocet_zivych);
      if puvodni[radek+1,sloupec-1]='O' then Inc(pocet_zivych);
      if puvodni[radek+1,sloupec]='O' then Inc(pocet_zivych);
      if puvodni[radek+1,sloupec+1]='O' then Inc(pocet_zivych);
      nove[radek,sloupec]:=puvodni[radek,sloupec];
      if (puvodni[radek,sloupec]='O') and ((pocet_zivych<2) or (pocet_zivych>3)) then
        nove[radek,sloupec]:='.';
      if (puvodni[radek,sloupec]='.') and (pocet_zivych=3) then
        nove[radek,sloupec]:='O';
    end;
  for radek:=1 to pocet do
  begin
    temp:='';
    for sloupec:=1 to delka do
    begin
      puvodni[radek,sloupec]:=nove[radek,sloupec];
      temp:=temp + nove[radek,sloupec];
    end;
    Memo1.Lines[radek-1]:=temp;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
    if pocet_kroku>=StrToInt(Edit1.Text) then
    begin
      pocet_kroku:=0;
      ProgressBar1.Position:=0;
    end;
  JedenKrok;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
  pocet_kroku:=0;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if bezi_animace then
  begin
    bezi_animace:=false;
    Button2.Enabled:=true;
    Button1.Caption:='Spustit animaci';
    Timer1.Enabled:=false;
  end
  else
  begin
    if pocet_kroku>=StrToInt(Edit1.Text) then
    begin
      pocet_kroku:=0;
      ProgressBar1.Position:=0;
    end;
    bezi_animace:=true;
    Button2.Enabled:=false;
    Button1.Caption:='Zastavit animaci';
    Timer1.Interval:=StrToInt(Edit2.Text);
    Timer1.Enabled:=true;
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if pocet_kroku>=StrToInt(Edit1.Text) then
  begin
    bezi_animace:=false;
    Button2.Enabled:=true;
    Button1.Caption:='Spustit animaci';
    Timer1.Enabled:=false;
  end
  else JedenKrok;
end;

end.
